Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/dataanalysis.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs	(revision 7294)
@@ -2518,4 +3218,503 @@
 
     /*************************************************************************
+    Neural networks ensemble
+    *************************************************************************/
+    public class mlpensemble
+    {
+        //
+        // Public declarations
+        //
+
+        public mlpensemble()
+        {
+            _innerobj = new mlpe.mlpensemble();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private mlpe.mlpensemble _innerobj;
+        public mlpe.mlpensemble innerobj { get { return _innerobj; } }
+        public mlpensemble(mlpe.mlpensemble obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+    /*************************************************************************
+    Like MLPCreate0, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreate0(int nin, int nout, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreate0(nin, nout, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreate1, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreate1(int nin, int nhid, int nout, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreate1(nin, nhid, nout, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreate2, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreate2(int nin, int nhid1, int nhid2, int nout, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreate2(nin, nhid1, nhid2, nout, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateB0, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreateb0(int nin, int nout, double b, double d, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreateb0(nin, nout, b, d, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateB1, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreateb1(int nin, int nhid, int nout, double b, double d, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreateb1(nin, nhid, nout, b, d, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateB2, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreateb2(int nin, int nhid1, int nhid2, int nout, double b, double d, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreateb2(nin, nhid1, nhid2, nout, b, d, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateR0, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreater0(int nin, int nout, double a, double b, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreater0(nin, nout, a, b, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateR1, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreater1(int nin, int nhid, int nout, double a, double b, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreater1(nin, nhid, nout, a, b, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateR2, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreater2(int nin, int nhid1, int nhid2, int nout, double a, double b, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreater2(nin, nhid1, nhid2, nout, a, b, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateC0, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreatec0(int nin, int nout, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreatec0(nin, nout, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateC1, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreatec1(int nin, int nhid, int nout, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreatec1(nin, nhid, nout, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Like MLPCreateC2, but for ensembles.
+
+      -- ALGLIB --
+         Copyright 18.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreatec2(int nin, int nhid1, int nhid2, int nout, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreatec2(nin, nhid1, nhid2, nout, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Creates ensemble from network. Only network geometry is copied.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpecreatefromnetwork(multilayerperceptron network, int ensemblesize, out mlpensemble ensemble)
+    {
+        ensemble = new mlpensemble();
+        mlpe.mlpecreatefromnetwork(network.innerobj, ensemblesize, ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Randomization of MLP ensemble
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlperandomize(mlpensemble ensemble)
+    {
+
+        mlpe.mlperandomize(ensemble.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Return ensemble properties (number of inputs and outputs).
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpeproperties(mlpensemble ensemble, out int nin, out int nout)
+    {
+        nin = 0;
+        nout = 0;
+        mlpe.mlpeproperties(ensemble.innerobj, ref nin, ref nout);
+        return;
+    }
+
+    /*************************************************************************
+    Return normalization type (whether ensemble is SOFTMAX-normalized or not).
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static bool mlpeissoftmax(mlpensemble ensemble)
+    {
+
+        bool result = mlpe.mlpeissoftmax(ensemble.innerobj);
+        return result;
+    }
+
+    /*************************************************************************
+    Procesing
+
+    INPUT PARAMETERS:
+        Ensemble-   neural networks ensemble
+        X       -   input vector,  array[0..NIn-1].
+        Y       -   (possibly) preallocated buffer; if size of Y is less than
+                    NOut, it will be reallocated. If it is large enough, it
+                    is NOT reallocated, so we can save some time on reallocation.
+
+
+    OUTPUT PARAMETERS:
+        Y       -   result. Regression estimate when solving regression  task,
+                    vector of posterior probabilities for classification task.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpeprocess(mlpensemble ensemble, double[] x, ref double[] y)
+    {
+
+        mlpe.mlpeprocess(ensemble.innerobj, x, ref y);
+        return;
+    }
+
+    /*************************************************************************
+    'interactive'  variant  of  MLPEProcess  for  languages  like Python which
+    support constructs like "Y = MLPEProcess(LM,X)" and interactive mode of the
+    interpreter
+
+    This function allocates new array on each call,  so  it  is  significantly
+    slower than its 'non-interactive' counterpart, but it is  more  convenient
+    when you call it from command line.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpeprocessi(mlpensemble ensemble, double[] x, out double[] y)
+    {
+        y = new double[0];
+        mlpe.mlpeprocessi(ensemble.innerobj, x, ref y);
+        return;
+    }
+
+    /*************************************************************************
+    Relative classification error on the test set
+
+    INPUT PARAMETERS:
+        Ensemble-   ensemble
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        percent of incorrectly classified cases.
+        Works both for classifier betwork and for regression networks which
+    are used as classifiers.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlperelclserror(mlpensemble ensemble, double[,] xy, int npoints)
+    {
+
+        double result = mlpe.mlperelclserror(ensemble.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Average cross-entropy (in bits per element) on the test set
+
+    INPUT PARAMETERS:
+        Ensemble-   ensemble
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        CrossEntropy/(NPoints*LN(2)).
+        Zero if ensemble solves regression task.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpeavgce(mlpensemble ensemble, double[,] xy, int npoints)
+    {
+
+        double result = mlpe.mlpeavgce(ensemble.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    RMS error on the test set
+
+    INPUT PARAMETERS:
+        Ensemble-   ensemble
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        root mean square error.
+        Its meaning for regression task is obvious. As for classification task
+    RMS error means error when estimating posterior probabilities.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpermserror(mlpensemble ensemble, double[,] xy, int npoints)
+    {
+
+        double result = mlpe.mlpermserror(ensemble.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Average error on the test set
+
+    INPUT PARAMETERS:
+        Ensemble-   ensemble
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        Its meaning for regression task is obvious. As for classification task
+    it means average error when estimating posterior probabilities.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpeavgerror(mlpensemble ensemble, double[,] xy, int npoints)
+    {
+
+        double result = mlpe.mlpeavgerror(ensemble.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Average relative error on the test set
+
+    INPUT PARAMETERS:
+        Ensemble-   ensemble
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        Its meaning for regression task is obvious. As for classification task
+    it means average relative error when estimating posterior probabilities.
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpeavgrelerror(mlpensemble ensemble, double[,] xy, int npoints)
+    {
+
+        double result = mlpe.mlpeavgrelerror(ensemble.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Training neural networks ensemble using  bootstrap  aggregating (bagging).
+    Modified Levenberg-Marquardt algorithm is used as base training method.
+
+    INPUT PARAMETERS:
+        Ensemble    -   model with initialized geometry
+        XY          -   training set
+        NPoints     -   training set size
+        Decay       -   weight decay coefficient, >=0.001
+        Restarts    -   restarts, >0.
+
+    OUTPUT PARAMETERS:
+        Ensemble    -   trained model
+        Info        -   return code:
+                        * -2, if there is a point with class number
+                              outside of [0..NClasses-1].
+                        * -1, if incorrect parameters was passed
+                              (NPoints<0, Restarts<1).
+                        *  2, if task has been solved.
+        Rep         -   training report.
+        OOBErrors   -   out-of-bag generalization error estimate
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpebagginglm(mlpensemble ensemble, double[,] xy, int npoints, double decay, int restarts, out int info, out mlpreport rep, out mlpcvreport ooberrors)
+    {
+        info = 0;
+        rep = new mlpreport();
+        ooberrors = new mlpcvreport();
+        mlpe.mlpebagginglm(ensemble.innerobj, xy, npoints, decay, restarts, ref info, rep.innerobj, ooberrors.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Training neural networks ensemble using  bootstrap  aggregating (bagging).
+    L-BFGS algorithm is used as base training method.
+
+    INPUT PARAMETERS:
+        Ensemble    -   model with initialized geometry
+        XY          -   training set
+        NPoints     -   training set size
+        Decay       -   weight decay coefficient, >=0.001
+        Restarts    -   restarts, >0.
+        WStep       -   stopping criterion, same as in MLPTrainLBFGS
+        MaxIts      -   stopping criterion, same as in MLPTrainLBFGS
+
+    OUTPUT PARAMETERS:
+        Ensemble    -   trained model
+        Info        -   return code:
+                        * -8, if both WStep=0 and MaxIts=0
+                        * -2, if there is a point with class number
+                              outside of [0..NClasses-1].
+                        * -1, if incorrect parameters was passed
+                              (NPoints<0, Restarts<1).
+                        *  2, if task has been solved.
+        Rep         -   training report.
+        OOBErrors   -   out-of-bag generalization error estimate
+
+      -- ALGLIB --
+         Copyright 17.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpebagginglbfgs(mlpensemble ensemble, double[,] xy, int npoints, double decay, int restarts, double wstep, int maxits, out int info, out mlpreport rep, out mlpcvreport ooberrors)
+    {
+        info = 0;
+        rep = new mlpreport();
+        ooberrors = new mlpcvreport();
+        mlpe.mlpebagginglbfgs(ensemble.innerobj, xy, npoints, decay, restarts, wstep, maxits, ref info, rep.innerobj, ooberrors.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Training neural networks ensemble using early stopping.
+
+    INPUT PARAMETERS:
+        Ensemble    -   model with initialized geometry
+        XY          -   training set
+        NPoints     -   training set size
+        Decay       -   weight decay coefficient, >=0.001
+        Restarts    -   restarts, >0.
+
+    OUTPUT PARAMETERS:
+        Ensemble    -   trained model
+        Info        -   return code:
+                        * -2, if there is a point with class number
+                              outside of [0..NClasses-1].
+                        * -1, if incorrect parameters was passed
+                              (NPoints<0, Restarts<1).
+                        *  6, if task has been solved.
+        Rep         -   training report.
+        OOBErrors   -   out-of-bag generalization error estimate
+
+      -- ALGLIB --
+         Copyright 10.03.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpetraines(mlpensemble ensemble, double[,] xy, int npoints, double decay, int restarts, out int info, out mlpreport rep)
+    {
+        info = 0;
+        rep = new mlpreport();
+        mlpe.mlpetraines(ensemble.innerobj, xy, npoints, decay, restarts, ref info, rep.innerobj);
+        return;
+    }
+
+}
+public partial class alglib
+{
+
+
+    /*************************************************************************
     Principal components analysis
 
